unit TClassExample;

interface

uses SysUtils;

type
   TTestClass = class
   strict private
      procedure HelloPrivate;
   private
      Data : String;
      procedure HelloLocal;
   public
      constructor Create (AData : String);
      procedure Hello;
   end;
   
type
   TBaseClass = class end;
   TDerivClass = class (TBaseClass);
   
   TAbstractClass = class
      procedure Invariant (arg : TDerivClass);
                   virtual; abstract;
      procedure NotReally; virtual;
   end;
   TConcreteClass = class (TAbstractClass)
      procedure Invariant (arg : TDerivClass); override;
      procedure NotReally; reintroduce;
   end;
   
implementation

procedure TAbstractClass.NotReally;
begin
   WriteLn ('TAbstractClass.NotReally;')
end;

procedure TConcreteClass.Invariant(arg : TDerivClass);
begin
   WriteLn ('TConcreteClass.Invariant(TDerivClass);');
   arg.Destroy
end;

procedure TConcreteClass.NotReally;
begin
   WriteLn ('TConcreteClass.NotReally;')
end;

procedure TTestClass.HelloPrivate;
begin
   WriteLn ('TTestClass.HelloPrivate: ', Data);
end;

procedure TTestClass.HelloLocal;
begin
   WriteLn ('TTestClass.HelloLocal: ', Data);
end;

procedure TTestClass.Hello;
begin
   Write ('TTestClass.Hello: calling '); HelloPrivate;
   WriteLn ('continuing TTestClass.Hello: ', Data);
end;

constructor TTestClass.Create (AData : String);
begin
   Data := AData;
end;

var L : TTestClass;

begin
   L := TTestClass.Create ('Initializer');
   //L.HelloPrivate;
   L.HelloLocal;
   L.Free;
end.
