{ -*- compile-command: "fpc -gh constructor_called_on_class_or_instance.pas" -*- }
{$mode objfpc}{$H+}

uses SysUtils;

type
  TMyObject = class
    class procedure CreateMe(out Res: TMyObject);
    constructor Create;
    constructor Create2;
  end;

class procedure TMyObject.CreateMe(out Res: TMyObject);
begin
  { allowed and valid: we're in a class procedure, so constructor
   allocates memory and creates new instance as usual }
  Res := TMyObject.Create;
end;

constructor TMyObject.Create;
var
  M: TMyObject;
begin
  { not allowed, constructor is just a normal method without any return value
    (like a procedure, not a function) when calling on an instance }
//  M := Create2;
//  M := Self.Create2;

  { this is of course allowed, as usual }
  M := TMyObject.Create2;
  FreeAndNil(M);
end;

constructor TMyObject.Create2;
begin
end;

var
  M: TMyObject;
begin
  M := TMyObject.Create;
  FreeAndNil(M);
  TMyObject.CreateMe(M);
  FreeAndNil(M);
end.